code/DpcManagement/DpcManagement/Controllers/LoginController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using DpcManagement.Models;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;

namespace DpcManagement.Controllers
{
    public class LoginController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly IConfiguration _config;
        BPOApiClient.Core.ApiClient apiClient = new BPOApiClient.Core.ApiClient();

        public LoginController(IConfiguration config, ILogger<HomeController> logger)
        {
            _config = config;
            _logger = logger;
            apiClient.SetAddress(_config["AppSettings:ServerApiDpc"]);
        }
        // GET: Login
        [HttpGet]
        public ActionResult Index(string RequestPath = null)
        {
            ViewData["RequestPath"] = RequestPath;
            return View();
        }
        [HttpPost]
        public async Task<IActionResult> Index(Account acc, string RequestPath = null)
        {
            try
            {
                //_logger.LogDebug("Login port "+JsonConvert.SerializeObject(acc));
                var token = apiClient.PostPrc("api/auth/getToken", acc);
                //_logger.LogDebug("Login port success"+JsonConvert.SerializeObject(token));
                if (token.status)
                {
                    var login = JsonConvert.DeserializeObject<LoginToken>(token.result);
                    // create claims
                    List<Claim> claims = new List<Claim>
                        {
                            new Claim("Name", login.Login),
                            new Claim("Token", login.IdTokenManagement),
                            new Claim("Role","admin"),
                           // new Claim(ClaimTypes.Role,"user")
                        };

                    // create identity
                    ClaimsIdentity identity = new ClaimsIdentity(claims, "cookie");

                    // create principal
                    ClaimsPrincipal principal = new ClaimsPrincipal(identity);

                    // sign-in
                    await HttpContext.SignInAsync(
                            scheme: "SecurityScheme",
                            principal: principal,
                            properties: new AuthenticationProperties
                            {
                                //IsPersistent = true, // for 'remember me' feature
                                //ExpiresUtc = DateTime.UtcNow.AddMinutes(1)
                            });
                    if (RequestPath==null)
                    {
                        return RedirectToAction("User", "Home");
                    }
                    return Redirect(RequestPath ?? "/");
                    
                }
                else
                {

                    ModelState.AddModelError("", "Tên đăng nhập hoăc mật khẩu không đúng.");
                }
                return View();
            }
            catch (Exception e)
            {
                ModelState.AddModelError("", "Kiểm tra lại đường truyền.");
                return View();
            }
        }

        public async Task<IActionResult> Logout(string requestPath)
        {
            await HttpContext.SignOutAsync(
                    scheme: "SecurityScheme");

            return RedirectToAction("Index");
        }
    }
}

code/DpcManagement/DpcManagement/Controllers/PackageController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using DpcManagement.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;

namespace DpcManagement.Controllers
{
    public class PackageController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly IConfiguration _config;
        BPOApiClient.Core.ApiClient apiClient = new BPOApiClient.Core.ApiClient();

        public PackageController(IConfiguration config, ILogger<HomeController> logger)
        {
            _config = config;
            _logger = logger;
            apiClient.SetAddress(_config["AppSettings:ServerApiDpc"]);
        }
        [HttpGet]
        //[Authorize]
        public  IActionResult Index()
        {

            var str = apiClient.Get("api/package", "");
            var packages = JsonConvert.DeserializeObject<List<Package>>(str);
            return View(packages);
        }
        [HttpPost]
        public IActionResult Index(Package package, IFormFile file1)
        {
            if (file1?.Length>0)
            {
                package.DateCreate = DateTime.Now;
                package.IsDelete = false;
                using (var ms = new MemoryStream())
                {
                    file1.CopyTo(ms);
                    var fileBytes = ms.ToArray();
                    var t = apiClient.PostFile("api/package/create"
                                                    , fileBytes, file1.FileName
                                                    , "file"
                                                    , package
                                                    , "strPackage");
                  
                }
            }
            return  RedirectToAction("Index"); 
        }
        [HttpPost]
        public IActionResult Export(Package package)
        {
            if (package.PackageId!=0)
            {
                var res = apiClient.PostPrc("api/Package/Export", package);

            }
            return RedirectToAction("Index");
        }
    }
}

code/DpcManagement/DpcManagement/Views/Shared/_FooterMA.cshtml
<div class="page-footer">
    <div class="page-footer-inner">
        2020 &copy; DPC Management
        <a target="_blank" href="https://www.google.com.vn/">Google</a> &nbsp;|&nbsp;
        <a href="https://www.facebook.com/" title="https://www.facebook.com/" target="_blank">Facebook!</a>
    </div>
    <div class="scroll-to-top">
        <i class="icon-arrow-up"></i>
    </div>
</div>

code/DpcManagement/DpcManagement/Views/Shared/_HeaderMa.cshtml
@{
    var identity = (System.Security.Claims.ClaimsIdentity)Context.User.Identity;

    var claim1 = identity.Claims.FirstOrDefault(c => c.Type == "Name");
    var t = 1;
}
<div class="page-header navbar navbar-fixed-top">
    <!-- BEGIN HEADER INNER -->
    <div class="page-header-inner ">
        <!-- BEGIN LOGO -->
        <div class="page-logo">
            <a href="index-2.html">
                <img src="~/assets/layouts/layout/img/logo.png" alt="logo" class="logo-default" />
            </a>
            <div class="menu-toggler sidebar-toggler">
                <span></span>
            </div>
        </div>
        <!-- END LOGO -->
        <!-- BEGIN RESPONSIVE MENU TOGGLER -->
        <a href="javascript:;" class="menu-toggler responsive-toggler" data-toggle="collapse" data-target=".navbar-collapse">
            <span></span>
        </a>
        <!-- END RESPONSIVE MENU TOGGLER -->
        <!-- BEGIN TOP NAVIGATION MENU -->
        <div class="top-menu">
            <ul class="nav navbar-nav pull-right">
                <!-- BEGIN NOTIFICATION DROPDOWN -->
                <li class="dropdown dropdown-extended dropdown-notification" id="header_notification_bar">
                    <a href="javascript:;" class="dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-close-others="true">
                        <i class="icon-bell"></i>
                        <span class="badge badge-default"> 7 </span>
                    </a>
                    <ul class="dropdown-menu">
                        <li class="external">
                            <h3>
                                <span class="bold">12 pending</span> notifications
                            </h3>
                            <a href="page_user_profile_1.html">view all</a>
                        </li>
                        <li>
                            <ul class="dropdown-menu-list scroller" style="height: 250px;" data-handle-color="#637283">
                                <li>
                                    <a href="javascript:;">
                                        <span class="time">just now</span>
                                        <span class="details">
                                            <span class="label label-sm label-icon label-success">
                                                <i class="fa fa-plus"></i>
                                            </span> New user registered.
                                        </span>
                                    </a>
                                </li>
                                <li>
                                    <a href="javascript:;">
                                        <span class="time">3 mins</span>
                                        <span class="details">
                                            <span class="label label-sm label-icon label-danger">
                                                <i class="fa fa-bolt"></i>
                                            </span> Server #12 overloaded.
                                        </span>
                                    </a>
                                </li>
                                <li>
                                    <a href="javascript:;">
                                        <span class="time">10 mins</span>
                                        <span class="details">
                                            <span class="label label-sm label-icon label-warning">
                                                <i class="fa fa-bell-o"></i>
                                            </span> Server #2 not responding.
                                        </span>
                                    </a>
                                </li>
                                <li>
                                    <a href="javascript:;">
                                        <span class="time">14 hrs</span>
                                        <span class="details">
                                            <span class="label label-sm label-icon label-info">
                                                <i class="fa fa-bullhorn"></i>
                                            </span> Application error.
                                        </span>
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </li>
                <!-- END NOTIFICATION DROPDOWN -->
                <!-- BEGIN USER LOGIN DROPDOWN -->
                @if (claim1 == null)
                {
                    <li class="dropdown dropdown-user">
                        <a  class="dropdown-toggle" asp-controller="Login" asp-action="Index">
                            <span class="username username-hide-on-mobile"> Login </span>
                        </a>
                    </li>
                }
                else
                {

                    <li class="dropdown dropdown-user">
                        <a href="javascript:;" class="dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-close-others="true">
                            <img alt="" class="img-circle" src="~/assets/layouts/layout/img/avatar3_small.jpg" />
                            <span class="username username-hide-on-mobile"> @claim1.Value </span>
                            <i class="fa fa-angle-down"></i>
                        </a>
                        <ul class="dropdown-menu dropdown-menu-default">
                            <li>
                                <a href="page_user_profile_1.html">
                                    <i class="icon-user"></i> My Profile
                                </a>
                            </li>
                            <li>
                                <a href="app_todo.html">
                                    <i class="icon-rocket"></i> My Tasks
                                    <span class="badge badge-success"> 7 </span>
                                </a>
                            </li>
                            <li class="divider"> </li>
                            <li>
                                <a href="page_user_lock_1.html">
                                    <i class="icon-lock"></i> Lock Screen
                                </a>
                            </li>
                            <li>
                                <a asp-controller="Login" asp-action="Logout">
                                    <i class="icon-key"></i> Log Out
                                </a>
                            </li>
                        </ul>
                    </li>
                }
                <!-- END USER LOGIN DROPDOWN -->
            </ul>
        </div>
        <!-- END TOP NAVIGATION MENU -->
    </div>
    <!-- END HEADER INNER -->
</div>

code/DpcManagement/DpcManagement/Views/Shared/_Layout.cshtml
@{
    var claimr = System.Security.Claims.ClaimsPrincipal.Current;
    System.Security.Claims.Claim claim2 = claimr.FindFirst("Name");

    var identity = (System.Security.Claims.ClaimsIdentity)Context.User.Identity;
    var claim1 = identity.Claims.FirstOrDefault(c => c.Type == "Name");
}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - DpcManagement</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">DpcManagement</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - DpcManagement - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

code/DpcManagement/DpcManagement/Views/Shared/_SideBarMA.cshtml
@{
    var identity = (System.Security.Claims.ClaimsIdentity)Context.User.Identity;

    var claim1 = identity.Claims.FirstOrDefault(c => c.Type == "Name");
    var t = 1;
}

<div class="page-sidebar-wrapper">
    <!-- BEGIN SIDEBAR -->
    <div class="page-sidebar navbar-collapse collapse">
        <!-- BEGIN SIDEBAR MENU -->
        <ul class="page-sidebar-menu  page-header-fixed " data-keep-expanded="false" data-auto-scroll="true" data-slide-speed="200" style="padding-top: 20px">
            <!-- BEGIN SIDEBAR TOGGLER BUTTON -->
            <li class="sidebar-toggler-wrapper hide">
                <div class="sidebar-toggler">
                    <span></span>
                </div>
            </li>
            <!-- END SIDEBAR TOGGLER BUTTON -->
            <li class="sidebar-search-wrapper">
                <!-- BEGIN RESPONSIVE QUICK SEARCH FORM -->
                <form class="sidebar-search  " action="http://keenthemes.com/preview/metronic/theme/admin_1/page_general_search_3.html" method="POST">
                    <a href="javascript:;" class="remove">
                        <i class="icon-close"></i>
                    </a>
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search...">
                        <span class="input-group-btn">
                            <a href="javascript:;" class="btn submit">
                                <i class="icon-magnifier"></i>
                            </a>
                        </span>
                    </div>
                </form>
                <!-- END RESPONSIVE QUICK SEARCH FORM -->
            </li>
            @if (claim1 == null)
            {
                <li class="nav-item start active open">
                    <a class="nav-link nav-toggle" asp-area="" asp-controller="Home" asp-action="Index">
                        <i class="icon-home"></i>
                        <span class="title">Home Page</span>
                        <span class="selected"></span>
                    </a>
                </li>
            }
            else
            {
                <li class="nav-item start active open">
                    <a class="nav-link nav-toggle" asp-area="" asp-controller="Home" asp-action="User">
                        <i class="icon-home"></i>
                        <span class="title">Home Page</span>
                        <span class="selected"></span>
                    </a>
                </li>
                <li class="heading">
                    <h3 class="uppercase">Management</h3>
                </li>
                <li class="nav-item  ">
                    <a href="http://www.google.com.vn" class="nav-link nav-toggle">
                        <i class="icon-diamond"></i>
                        <span class="title">Purchase Orders</span>
                    </a>
                </li>
                <li class="nav-item  ">
                    <a class="nav-link nav-toggle" asp-area="" asp-controller="Package" asp-action="Index">
                        <i class="icon-puzzle"></i>
                        <span class="title">Packages</span>
                    </a>
                </li>
                <li class="nav-item  ">
                    <a class="nav-link nav-toggle" asp-area="" asp-controller="PackageMdgc" asp-action="Index">
                        <i class="icon-settings"></i>
                        <span class="title">Packages MDGC</span>
                    </a>
                </li>
                <li class="nav-item  hide">
                    <a href="javascript:;" class="nav-link nav-toggle">
                        <i class="icon-briefcase"></i>
                        <span class="title">Tables</span>
                        <span class="arrow"></span>
                    </a>
                    <ul class="sub-menu">
                        <li class="nav-item  ">
                            <a href="table_bootstrap.html" class="nav-link ">
                                <span class="title">Bootstrap Tables</span>
                            </a>
                        </li>
                        <li class="nav-item  ">
                            <a href="javascript:;" class="nav-link nav-toggle">
                                <span class="title">Datatables</span>
                                <span class="arrow"></span>
                            </a>
                            <ul class="sub-menu">
                                <li class="nav-item ">
                                    <a href="table_datatables_managed.html" class="nav-link "> Managed Datatables </a>
                                </li>
                                <li class="nav-item ">
                                    <a href="table_datatables_buttons.html" class="nav-link "> Buttons Extension </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </li>

            }
        </ul>
        <!-- END SIDEBAR MENU -->
        <!-- END SIDEBAR MENU -->
    </div>
    <!-- END SIDEBAR -->
</div>